
#if !defined(AFX_9500APP_H__B98F829F_2028_4C85_8741_3F87A563F442__INCLUDED_)
#define AFX_9500APP_H__B98F829F_2028_4C85_8741_3F87A563F442__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"

/* Basic type definitions */
typedef unsigned char   BYTE, *PBYTE;
typedef unsigned short  WORD, *PWORD;
typedef unsigned long   DWORD, *PDWORD;
typedef unsigned __int64 DWORD64, *PDWORD64;

#define OID_NDIS_SMSC_LAN_READ_REGS     			0xFFFF0001U
#define OID_NDIS_SMSC_PHY_READ_REGS     			0xFFFF0002U
#define OID_NDIS_SMSC_LAN_WRITE_REGS     			0xFFFF0003U
#define OID_NDIS_SMSC_PHY_WRITE_REGS     			0xFFFF0004U
#define OID_NDIS_SMSC_DUMP_LAN_REGS     			0xFFFF0005U
#define OID_NDIS_SMSC_DUMP_MAC_REGS				0xFFFF0006U
#define OID_NDIS_SMSC_DUMP_PHY_REGS     			0xFFFF0007U
#define OID_NDIS_SMSC_DUMP_TX_STATS     			0xFFFF0008U
#define OID_NDIS_SMSC_DUMP_RX_STATS     			0xFFFF0009U
#define OID_NDIS_SMSC_SAVE_E2P_TO_FILE     		0xFFFF000AU
#define OID_NDIS_SMSC_ERASE_E2P     				0xFFFF000BU
#define OID_NDIS_SMSC_WRITE_FILE_TO_E2P     		0xFFFF000CU
#define OID_NDIS_SMSC_SEND_E2P_COMMAND			0xFFFF000DU
#define OID_NDIS_SMSC_READ_E2P    					0xFFFF000EU
#define OID_NDIS_SMSC_WRITE_E2P    	 			0xFFFF000FU
#define OID_NDIS_SMSC_READ_E2P_BLOCK    			0xFFFF0010U
#define OID_NDIS_SMSC_WRITE_E2P_BLOCK     			0xFFFF0011U
#define OID_NDIS_SMSC_GET_E2P_SIZE  				0xFFFF0012U
#define OID_NDIS_SMSC_GET_DRIVER_INFO   			0xFFFF0013U
#define OID_NDIS_SMSC_ENABLE_DEBUG   			       0xFFFF0014U
#define OID_NDIS_SMSC_ENABLE_RESUME   			0xFFFF0015U
#define OID_NDIS_SMSC_SET_DEBUG_FLAG				0xFFFF0016U
#define OID_NDIS_SMSC_SET_COUNT_FLAG				0xFFFF0017U

// E2pCmdType:
#define	E2P_CMD_EWDS			0x10000000UL // Erase/Write Disable
#define	E2P_CMD_EWEN			0x20000000UL // Erase/Write Enable
#define	E2P_CMD_ERAL			0x60000000UL // Erase All


typedef struct _DEV_DESC
{
	BYTE bLength;            // DFLT=12h, Loaded from E2P=Yes, E2P Content=Don't care
	BYTE bDescriptorType;    // DFLT=01h, Loaded from E2P=Yes, E2P Content=Don't care
	WORD bcdUSB;             // DFLT=0200h, Loaded from E2P=Yes, E2P Content=Must be 0200h
	BYTE bDeviceClass;       // DFLT=FFh, Loaded from E2P=Yes, E2P Content=FFh
	BYTE bDeviceSubClass;    // DFLT=00h, Loaded from E2P=Yes, E2P Content=00
	BYTE bDeviceProtocol;    // DFLT=01h, Loaded from E2P=Yes, E2P Content=01
	BYTE bMaxPacketSize;     // DFLT=40h, Loaded from E2P=Yes, E2P Content=Must be 40h
	WORD IdVendor;           // DFLT=0424h, Loaded from E2P=Yes, E2P Content=programmable using GUI
	WORD IdProduct;          // DFLT=9500h, Loaded from E2P=Yes, E2P Content=programmable using GUI
	WORD bcdDevice;          // DFLT=0100h, Loaded from E2P=Yes, E2P Content=0100
	BYTE iManufacturer;      // DFLT=00h, Loaded from E2P=Yes, E2P Content=Must be 1 if Manufacturer str. is enable in GUI
	BYTE iProduct;           // DFLT=00h, Loaded from E2P=Yes, E2P Content=Must be 2 if Manufacturer str. is enable in GUI
	BYTE iSerialNumber;      // DFLT=00h, Loaded from E2P=Yes, E2P Content=Must be 3
	BYTE bNumConfigurations; // DFLT=01h, Loaded from E2P=Yes, E2P Content=Must be 01h
}DEV_DESC, *PDEV_DESC;

typedef struct _CFG_DESC
{
	BYTE bLength;            // DFLT=09h, Loaded from E2P=Yes, E2P Content=Must be 09h
	BYTE bDescriptorType;    // DFLT=02h, Loaded from E2P=Yes, E2P Content=Don't care
	WORD wTotalLength;       // DFLT=0027h, Loaded from E2P=Yes, E2P Content=Must be 0027h
	BYTE bNumInterfaces;     // DFLT=01h, Loaded from E2P=Yes, E2P Content=Must be 01h
	BYTE bConfigurationValue;// DFLT=01h, Loaded from E2P=Yes, E2P Content=Must be 01h
	BYTE iConfiguration;     // DFLT=00h, Loaded from E2P=Yes, E2P Content=Must be 4 if Manufacturer str. is enable in GUI
	BYTE bmAttributes;       // DFLT=A0h, Loaded from E2P=Yes, E2P Content=programmable using GUI
	BYTE bMaxPower;          // DFLT=01h(Self power)/FAh(Bus Power), Loaded from E2P=Yes, E2P Content=programmable using GUI
}CFG_DESC, *PCFG_DESC;

typedef struct _IF_DESC
{
	BYTE bLength;            // DFLT=09h, Loaded from E2P=Yes, E2P Content=Must be 09h
	BYTE bDescriptorType;    // DFLT=04h, Loaded from E2P=Yes, E2P Content=Must be 04h
	BYTE bIntefaceNumber;    // DFLT=00h, Loaded from E2P=Yes, E2P Content=Must be 00h
	BYTE bAlternateSetting;  // DFLT=00h, Loaded from E2P=Yes, E2P Content=Must be 00h
	BYTE bNumEndpoints;      // DFLT=03h, Loaded from E2P=Yes, E2P Content=Must be 03h
	BYTE bIntefaceClass;     // DFLT=FFh, Loaded from E2P=Yes, E2P Content=FFh
	BYTE bIntefaceSubClass;  // DFLT=00h, Loaded from E2P=Yes, E2P Content=00h
	BYTE bIntefaceProtocol;  // DFLT=FFh, Loaded from E2P=Yes, E2P Content=FFh
	BYTE iInterface;         // DFLT=00h, Loaded from E2P=Yes, E2P Content=Must be 5 if Manufacturer str. is enable in GUI
}IF_DESC, *PIF_DESC;

typedef union _E2P_STRUCT
{
	BYTE E2pBuf[512];
	struct
	{
		BYTE Signature;
		BYTE MacAddr[6];
		BYTE FsPollInterval;
		BYTE HsPollInterval;
		BYTE ConfigFlag;
		WORD LangId;
		BYTE ManufacturerStrLen;
		BYTE ManufacturerStrOffset;
		BYTE ProductStrLen;
		BYTE ProductStrOffset;
		BYTE SerialNumberStrLen;
		BYTE SerialNumberStrOffset;
		BYTE ConfigStrLen;
		BYTE ConfigStrOffset;
		BYTE InterfaceStrLen;
		BYTE InterfaceStrOffset;
		BYTE HsDeviceDescLen;
		BYTE HsDeviceDescOffset;
		BYTE HsCfgIfDescLen;
		BYTE HsCfgIfDescOffset;
		BYTE FsDeviceDescLen;
		BYTE FsDeviceDescOffset;
		BYTE FsCfgIfDescLen;
		BYTE FsCfgIfDescOffset;
		BYTE Reserved[2];

		DEV_DESC DevDesc;
		CFG_DESC CfgDesc;
		IF_DESC  IfDesc;

		WORD UnicodeStr[222];
	}format;
}E2P_STRUCT, *PE2P_STRUCT;

typedef struct _OID_E2P_STRUCT
{
    DWORD            E2pSize;           // Do not change the first three fields of the
    E2P_STRUCT 			eeprom;
} OID_E2P_STRUCT, *POID_E2P_STRUCT;

typedef struct _DRIVER_VERSION {
	DWORD	Major;
	DWORD	Minor;
	DWORD	Build;
	DWORD	Qfe;
}DRIVER_VERSION, *PDRIVER_VERSION;

#endif // !defined(AFX_9500APP_H__B98F829F_2028_4C85_8741_3F87A563F442__INCLUDED_)
